> For the complete documentation index, see [llms.txt](https://docs.nzoni.app/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.nzoni.app/angular/seo-and-ssr.md).

# SEO & SSR

### Seo Service

```typescript
export class SeoService {

  constructor(private title: Title,
              private meta: Meta,
              @Inject(DOCUMENT) private dom: Document) { }

  setCanonicalUrl(url:string){
    const head = this.dom.getElementsByTagName('head')[0];
    let element: HTMLLinkElement = this.dom.querySelector(`link[rel='canonical']`) || null
    if (element === null) {
      element = this.dom.createElement('link') as HTMLLinkElement;
      head.appendChild(element);
    }
    element.setAttribute('rel', 'canonical')
    element.setAttribute('href', url)
  }

  setLang(lang: string) {
    const head = this.dom.getElementsByTagName('html')[0];
    head.setAttribute('lang', lang)
  }

  setMetaTitle(title: string) {
    this.title.setTitle(title);
  }

  setMetaDescription(content: string) {
    this.meta.updateTag({
      name: 'description',
      content
    });
  }

  addMetaTag(content: string, name: string) {
    this.meta.addTag({
      name,
      content
    });
  }
}

```

### How to set meta title, meta description and canonical url?

```typescript

	constructor(private seoService: SeoService) {
	}

        ngOnit() {
            // Set up meta title
	    this.seoService.setMetaTitle('your_title_here');
	    // Set up meta description
	    this.seoService.setMetaDescription('your_description_here');
	    // set up canonical url
	    this.seoService.setCanonicalUrl('your_url')
        }
```

### How build ssr

```
ng build ssr
ng build prerender
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.nzoni.app/angular/seo-and-ssr.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
